%define majver %(echo %version | cut -d. -f1-2)

Name:          qt5-qtdeclarative
Version:       5.15.7
Release:       1mamba
Summary:       Qt5 declarative components
Group:         System/Libraries
Vendor:        openmamba
Distribution:  openmamba
Packager:      Silvan Calarco <silvan.calarco@mambasoft.it>
URL:           https://www.qt.io/
Source:        https://download.qt.io/official_releases/qt/%{majver}/%{version}/submodules/qtdeclarative-everywhere-opensource-src-%{version}.tar.xz
## upstream patches
## repo: https://invent.kde.org/qt/qt/qtdeclarative
## branch: kde/5.15
## git format-patch v5.15.7-lts-lgpl
Patch01: 0001-Document-that-StyledText-also-supports-nbsp-and-quot.patch
Patch02: 0002-Support-apos-in-styled-text.patch
Patch03: 0003-Remove-unused-QPointer-QQuickPointerMask.patch
Patch04: 0004-QQmlDelegateModel-Refresh-the-view-when-a-column-is-.patch
Patch05: 0005-Fix-sweep-step-for-tainted-QObject-JavaScript-wrappe.patch
Patch06: 0006-Revert-Fix-for-possible-crash-in-QSGDefaultLayer-gra.patch
Patch07: 0007-Fix-TapHandler-so-that-it-actually-registers-a-tap.patch
Patch08: 0008-Revert-Fix-TapHandler-so-that-it-actually-registers-.patch
Patch09: 0009-QQmlJs-FixedPoolArray-fix-UB-precondition-violation-.patch
Patch10: 0010-V4-Do-not-call-dtor-of-an-object-we-continue-to-use.patch
Patch11: 0011-Make-sure-QQuickWidget-and-its-offscreen-window-s-sc.patch
Patch12: 0012-QQuickItem-Guard-against-cycles-in-nextPrevItemInTab.patch
Patch13: 0013-QSGOpenGLDistanceFieldGlyphCache-fix-multiplication-.patch
Patch14: 0014-QSGOpenGLDistanceFieldGlyphCache-fix-UB-ordering-of-.patch
Patch15: 0015-Fix-Flickable-wheel-velocity-calculation.patch
Patch16: 0016-Fix-Flickable-with-QTBUG-56075-patch-applied.patch
Patch17: 0017-Reset-currentChanges-if-currentChanges-is-active-whe.patch
Patch18: 0018-Revert-Fix-ListView.isCurrentItem-when-used-with-Del.patch
License:       GPL
## AUTOBUILDREQ-BEGIN
BuildRequires: glibc-devel
BuildRequires: libgcc
BuildRequires: libglvnd-devel
BuildRequires: libstdc++6-devel
BuildRequires: qt5-qtbase-devel
## AUTOBUILDREQ-END
Provides:      libQt5Qml
Obsoletes:     libQt5Qml <= 5.15.2-1mamba
Provides:      libQt5Quick
Obsoletes:     libQt5Quick <= 5.15.2-1mamba
Provides:      libQt5QuickParticles
Obsoletes:     libQt5QuickParticles <= 5.15.2-1mamba
Provides:      libQt5QuickShapes
Obsoletes:     libQt5QuickShapes <= 5.15.2-1mamba
Provides:      libQt5QuickTest
Obsoletes:     libQt5QuickTest <= 5.15.2-1mamba
Provides:      libQt5QuickWidgets
Obsoletes:     libQt5QuickWidgets <= 5.15.2-1mamba
Requires:      qt5-qtquickcontrols = %{version}
Requires:      qt5-qtgraphicaleffects = %{version}

%description
Qt5 declarative components.

%package devel
Group:         Development/Libraries
Summary:       Development files for %{name}
Requires:      %{name} = %{?epoch:%epoch:}%{version}-%{release}
Requires:      pkg-config

%description devel
This package contains libraries and header files for developing applications that use %{name}.

%debug_package

%prep
%setup -q -n qtdeclarative-everywhere-src-%{version}
#-D -T
#:<< _EOF
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1

%build
#:<< _EOF
%_qt5_qmake

%make

%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"
%makeinstall INSTALL_ROOT=%{buildroot} STRIP=/bin/true

%clean
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_libdir}/libQt5Qml.so.*
%{_libdir}/libQt5QmlModels.so.*
%{_libdir}/libQt5QmlWorkerScript.so.*
%{_libdir}/libQt5Quick.so.*
%{_libdir}/libQt5QuickParticles.so.*
%{_libdir}/libQt5QuickShapes.so.*
%{_libdir}/libQt5QuickTest.so.*
%{_libdir}/libQt5QuickWidgets.so.*
%{_libdir}/metatypes/qt5quick_metatypes.json
%{_libdir}/metatypes/qt5quickparticles_metatypes.json
%{_libdir}/metatypes/qt5quickshapes_metatypes.json
%{_libdir}/metatypes/qt5quicktest_metatypes.json
%{_libdir}/metatypes/qt5qml_metatypes.json
%{_libdir}/metatypes/qt5qmlmodels_metatypes.json
%{_libdir}/metatypes/qt5qmlworkerscript_metatypes.json
%dir %{_libdir}/qt5/plugins/qmltooling
%{_libdir}/qt5/plugins/qmltooling/libqmldbg_*.so
%dir %{_libdir}/qt5/qml/Qt/labs/animation
%{_libdir}/qt5/qml/Qt/labs/animation/*
%dir %{_libdir}/qt5/qml/Qt/labs/folderlistmodel
%{_libdir}/qt5/qml/Qt/labs/folderlistmodel/*
%dir %{_libdir}/qt5/qml/Qt/labs/qmlmodels
%{_libdir}/qt5/qml/Qt/labs/qmlmodels/*
%dir %{_libdir}/qt5/qml/Qt/labs/settings
%{_libdir}/qt5/qml/Qt/labs/settings/*
%dir %{_libdir}/qt5/qml/Qt/labs/sharedimage
%{_libdir}/qt5/qml/Qt/labs/sharedimage/*
%dir %{_libdir}/qt5/qml/Qt/labs/wavefrontmesh
%{_libdir}/qt5/qml/Qt/labs/wavefrontmesh/*
%dir %{_libdir}/qt5/qml/Qt/test/qtestroot
%{_libdir}/qt5/qml/Qt/test/qtestroot/*
%dir %{_libdir}/qt5/qml/QtQml/Models.2
%{_libdir}/qt5/qml/QtQml/Models.2/*
%dir %{_libdir}/qt5/qml/QtQml/StateMachine
%{_libdir}/qt5/qml/QtQml/StateMachine/*
%dir %{_libdir}/qt5/qml/QtQml/WorkerScript.2
%{_libdir}/qt5/qml/QtQml/WorkerScript.2/*
%{_libdir}/qt5/qml/QtQml/libqmlplugin.so
%{_libdir}/qt5/qml/QtQml/plugins.qmltypes
%{_libdir}/qt5/qml/QtQml/qmldir
%dir %{_libdir}/qt5/qml/QtQuick.2
%{_libdir}/qt5/qml/QtQuick.2/*
%dir %{_libdir}/qt5/qml/QtQuick
%{_libdir}/qt5/qml/QtQuick/*
%dir %{_libdir}/qt5/qml/QtTest
%{_libdir}/qt5/qml/QtTest/*
%{_libdir}/qt5/qml/builtins.qmltypes
%{_libdir}/qt5/bin/qml*

%files devel
%defattr(-,root,root)
%dir %{_includedir}/qt5/QtPacketProtocol
%{_includedir}/qt5/QtPacketProtocol/*
%dir %{_includedir}/qt5/QtQml
%{_includedir}/qt5/QtQml/*
%dir %{_includedir}/qt5/QtQmlDebug
%{_includedir}/qt5/QtQmlDebug/*
%dir %{_includedir}/qt5/QtQmlModels
%{_includedir}/qt5/QtQmlModels/*
%dir %{_includedir}/qt5/QtQmlWorkerScript
%{_includedir}/qt5/QtQmlWorkerScript/*
%dir %{_includedir}/qt5/QtQuick
%{_includedir}/qt5/QtQuick/*
%dir %{_includedir}/qt5/QtQuickParticles
%{_includedir}/qt5/QtQuickParticles/*
%dir %{_includedir}/qt5/QtQuickShapes
%{_includedir}/qt5/QtQuickShapes/*
%dir %{_includedir}/qt5/QtQuickTest
%{_includedir}/qt5/QtQuickTest/*
%dir %{_includedir}/qt5/QtQuickWidgets
%{_includedir}/qt5/QtQuickWidgets/*
%{_libdir}/libQt5PacketProtocol.a
%{_libdir}/libQt5PacketProtocol.prl
%{_libdir}/libQt5Qml.prl
%{_libdir}/libQt5Qml.so
%{_libdir}/libQt5QmlDebug.a
%{_libdir}/libQt5QmlDebug.prl
%{_libdir}/libQt5QmlDevTools.a
%{_libdir}/libQt5QmlDevTools.prl
%{_libdir}/libQt5QmlModels.prl
%{_libdir}/libQt5QmlModels.so
%{_libdir}/libQt5QmlWorkerScript.prl
%{_libdir}/libQt5QmlWorkerScript.so
%{_libdir}/libQt5Quick.prl
%{_libdir}/libQt5Quick.so
%{_libdir}/libQt5QuickParticles.prl
%{_libdir}/libQt5QuickParticles.so
%{_libdir}/libQt5QuickShapes.prl
%{_libdir}/libQt5QuickShapes.so
%{_libdir}/libQt5QuickTest.prl
%{_libdir}/libQt5QuickTest.so
%{_libdir}/libQt5QuickWidgets.prl
%{_libdir}/libQt5QuickWidgets.so
%{_libdir}/qt5/mkspecs/features/qmlcache.prf
%{_libdir}/qt5/mkspecs/features/qmltypes.prf
%{_libdir}/qt5/mkspecs/features/qtquickcompiler.prf
%{_libdir}/qt5/mkspecs/modules/qt_lib_packetprotocol_private.pri
%{_libdir}/qt5/mkspecs/modules/qt_lib_qml*.pri
%{_libdir}/qt5/mkspecs/modules/qt_lib_quick*.pri
%dir %{_libdir}/cmake/Qt5PacketProtocol
%{_libdir}/cmake/Qt5PacketProtocol/Qt5PacketProtocolConfig*.cmake
%dir %{_libdir}/cmake/Qt5Qml
%{_libdir}/cmake/Qt5Qml/Qt5Qml*.cmake
%dir %{_libdir}/cmake/Qt5QmlDebug
%{_libdir}/cmake/Qt5QmlDebug/Qt5QmlDebugConfig*.cmake
%dir %{_libdir}/cmake/Qt5QmlDevTools
%{_libdir}/cmake/Qt5QmlDevTools/Qt5QmlDevTools*.cmake
%dir %{_libdir}/cmake/Qt5QmlImportScanner
%{_libdir}/cmake/Qt5QmlImportScanner/*
%dir %{_libdir}/cmake/Qt5QmlModels
%{_libdir}/cmake/Qt5QmlModels/Qt5QmlModelsConfig*.cmake
%dir %{_libdir}/cmake/Qt5QmlWorkerScript
%{_libdir}/cmake/Qt5QmlWorkerScript/Qt5QmlWorkerScriptConfig*.cmake
%dir %{_libdir}/cmake/Qt5Quick
%{_libdir}/cmake/Qt5Quick/Qt5QuickConfig*.cmake
%dir %{_libdir}/cmake/Qt5QuickCompiler
%{_libdir}/cmake/Qt5QuickCompiler/Qt5QuickCompilerConfig.cmake
%dir %{_libdir}/cmake/Qt5QuickParticles
%{_libdir}/cmake/Qt5QuickParticles/Qt5QuickParticlesConfig*.cmake
%dir %{_libdir}/cmake/Qt5QuickShapes
%{_libdir}/cmake/Qt5QuickShapes/Qt5QuickShapesConfig*.cmake
%dir %{_libdir}/cmake/Qt5QuickTest
%{_libdir}/cmake/Qt5QuickTest/Qt5QuickTestConfig*.cmake
%dir %{_libdir}/cmake/Qt5QuickWidgets
%{_libdir}/cmake/Qt5QuickWidgets/Qt5QuickWidgetsConfig*.cmake
%{_libdir}/pkgconfig/Qt5Qml.pc
%{_libdir}/pkgconfig/Qt5QmlModels.pc
%{_libdir}/pkgconfig/Qt5QmlWorkerScript.pc
%{_libdir}/pkgconfig/Qt5Quick.pc
%{_libdir}/pkgconfig/Qt5QuickTest.pc
%{_libdir}/pkgconfig/Qt5QuickWidgets.pc

%changelog
* Mon Nov 07 2022 Silvan Calarco <silvan.calarco@mambasoft.it> 5.15.7-1mamba
- update to 5.15.7

* Sat Nov 13 2021 Silvan Calarco <silvan.calarco@mambasoft.it> 5.15.2-3mamba
- require qt5-qtquickcontrols and qt5-qtgraphicaleffects

* Fri Nov 05 2021 Silvan Calarco <silvan.calarco@mambasoft.it> 5.15.2-2mamba
- bump release to allow update from monolithic build subpackage

* Fri Nov 05 2021 Silvan Calarco <silvan.calarco@mambasoft.it> 5.15.2-1mamba
- package created using the webbuild interface
